// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ImageEnProc.pas' rev: 3.00

#ifndef ImageEnProcHPP
#define ImageEnProcHPP
#include <ImageEnView.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Imageenproc
{
//-- type declarations -------------------------------------------------------
enum TResampleFilter { rfNone, rfTriangle, rfHermite, rfBell, rfBSpline, rfLanczos3, rfMitchell };

struct TGraphFilter
{
	int Values[3][3];
	int Divisor;
} ;

class DELPHICLASS EFilterInvalid;
class PASCALIMPLEMENTATION EFilterInvalid : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EFilterInvalid(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EFilterInvalid(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EFilterInvalid(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EFilterInvalid(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EFilterInvalid(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EFilterInvalid(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EFilterInvalid(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EFilterInvalid(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EFilterInvalid(void) { }
	
};

#pragma pack(push, 1)
struct TRGB
{
	Byte b;
	Byte g;
	Byte r;
} ;
#pragma pack(pop)

typedef TRGB *pRGB;

struct T3dPoint
{
	double x;
	double y;
	double z;
} ;

typedef TRGB RGBROW[134217728];

typedef RGBROW *pRGBROW;

typedef Byte ByteArray[134217728];

typedef ByteArray *pByteArray;

typedef TRGB *PRGBArray[134217728];

typedef PRGBArray *pPRGBArray;

enum TFlipDir { fdHorizontal, fdVertical };

typedef void __fastcall (__closure *TProgressEvent)(System::TObject* Sender, int per);

struct THistogramItem
{
	int R;
	int G;
	int B;
	int Gray;
} ;

typedef THistogramItem THistogram[256];

typedef THistogram *PHistogram;

enum ImageEnProc__2 { peAll, peContrast, peHSV, peHSL, peRGB, peUserFilt, peEqualize };

typedef Set<ImageEnProc__2, peAll, peEqualize>  TPreviewEffects;

class DELPHICLASS TImageEnProc;
class PASCALIMPLEMENTATION TImageEnProc : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool fAutoUndo;
	Graphics::TBitmap* fUndoBitmap;
	Graphics::TBitmap* fBitmap;
	Imageenview::TImageEnView* fImageEnView;
	int fSelx1;
	int fSely1;
	int fSelx2;
	int fSely2;
	Graphics::TColor fBackground;
	TProgressEvent fOnProgress;
	void __fastcall SetAttachedBitmap(Graphics::TBitmap* atBitmap);
	void __fastcall SetAttachedImageEn(Imageenview::TImageEnView* atImageEn);
	Graphics::TColor __fastcall GetReBackground(void);
	void __fastcall SetReBackground(Graphics::TColor v);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TImageEnProc(Classes::TComponent* Owner);
	__fastcall virtual ~TImageEnProc(void);
	__property Graphics::TBitmap* AttachedBitmap = {read=fBitmap, write=SetAttachedBitmap};
	void __fastcall Update(void);
	void __fastcall Negative(void);
	void __fastcall HSLvar(int oHue, int oSat, int oLum);
	void __fastcall HSVvar(int oHue, int oSat, int oVal);
	void __fastcall IntensityRGBall(int r, int g, int b);
	void __fastcall Contrast(int vv);
	void __fastcall ApplyFilter(const TGraphFilter &filter);
	void __fastcall ConvertToGray(void);
	void __fastcall CastColorRange(TRGB BeginColor, TRGB EndColor, TRGB CastColor);
	void __fastcall Rotate(int fangle, bool antialias);
	void __fastcall Flip(TFlipDir dir);
	void __fastcall Resize(int newWidth, int newHeight);
	void __fastcall Resample(int NewWidth, int NewHeight, TResampleFilter FilterType);
	void __fastcall DoPreviews(TPreviewEffects pe);
	void __fastcall Clear(void);
	void __fastcall Merge(Graphics::TBitmap* DBitmap, int pcf);
	void __fastcall Threshold(TRGB DownLimit, TRGB UpLimit, TRGB DownVal, TRGB UpVal);
	void __fastcall HistEqualize(TRGB LoThresh, TRGB HiThresh);
	void __fastcall HistAutoEqualize(void);
	void __fastcall ConvertTo(int NumColors);
	void __fastcall GetHistogram(THistogramItem * Hist);
	int __fastcall CalcImagePalette(const TRGB * Palette, const int Palette_Size, int MaxCol);
	int __fastcall CalcImageNumColors(void);
	void __fastcall SaveUndo(void);
	void __fastcall ClearUndo(void);
	void __fastcall Undo(void);
	void __fastcall SelCopyToClip(void);
	void __fastcall CopyToClipboard(void);
	void __fastcall SelPasteFromClipStretch(void);
	void __fastcall PasteFromClipboard(void);
	void __fastcall PointPasteFromClip(int x1, int y1);
	void __fastcall SelCutToClip(void);
	__property int SelX1 = {read=fSelx1, write=fSelx1, nodefault};
	__property int SelY1 = {read=fSely1, write=fSely1, nodefault};
	__property int SelX2 = {read=fSelx2, write=fSelx2, nodefault};
	__property int SelY2 = {read=fSely2, write=fSely2, nodefault};
	void __fastcall Select(int x1, int y1, int x2, int y2);
	void __fastcall SelectAll(void);
	bool __fastcall GetReSel(int &fsX1, int &fsY1, int &fsX2, int &fsY2);
	
__published:
	__property Imageenview::TImageEnView* AttachedImageEn = {read=fImageEnView, write=SetAttachedImageEn
		};
	__property bool AutoUndo = {read=fAutoUndo, write=fAutoUndo, default=1};
	__property Graphics::TColor Background = {read=GetReBackground, write=SetReBackground, default=0};
	__property TProgressEvent OnProgress = {read=fOnProgress, write=fOnProgress};
};

//-- var, const, procedure ---------------------------------------------------
#define MESS_256COLOR "This command doesn't work with 256 colors"
#define ppeColorAdjust (System::Set<ImageEnProc__2, peAll, peEqualize> () << peContrast << peHSV << peHSL \
	<< peRGB << peEqualize )
#define ppeEffects (System::Set<ImageEnProc__2, peAll, peEqualize> () << peUserFilt )
extern PACKAGE TRGB __fastcall CreateRGB(Byte r, Byte g, Byte b);
extern PACKAGE Graphics::TColor __fastcall TRGB2TColor(TRGB rgb);
extern PACKAGE TRGB __fastcall TColor2TRGB(Graphics::TColor cl);
extern PACKAGE float __fastcall dmin(float v1, float v2);
extern PACKAGE float __fastcall dmax(float v1, float v2);
extern PACKAGE int __fastcall imin(int v1, int v2);
extern PACKAGE int __fastcall imax(int v1, int v2);
extern PACKAGE int __fastcall ilimit(int vv, int min, int max);
extern PACKAGE int __fastcall blimit(int vv);
extern PACKAGE void __fastcall iswap(int &B1, int &B2);
extern PACKAGE bool __fastcall EqualRGB(TRGB rgb1, TRGB rgb2);
extern PACKAGE void __fastcall bswap(Byte &B1, Byte &B2);
extern PACKAGE void __fastcall OrdCor(int &x1, int &y1, int &x2, int &y2);
extern PACKAGE void __fastcall _ApplyFilter(Graphics::TBitmap* bitmap, const TGraphFilter &filter, int 
	fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE int __fastcall _GetMediaContrast(Graphics::TBitmap* bitmap);
extern PACKAGE void __fastcall _HSLvar(Graphics::TBitmap* bitmap, int oHue, int oSat, int oLum, int 
	fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _HSVvar(Graphics::TBitmap* bitmap, int oHue, int oSat, int oVal, int 
	fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _Rot90o(Graphics::TBitmap* bakbmp, Graphics::TBitmap* newbitmap);
extern PACKAGE void __fastcall _Rot90(Graphics::TBitmap* bakbmp, Graphics::TBitmap* newbitmap);
extern PACKAGE void __fastcall RGB2HSL(TRGB px, float &Hue, float &Sat, float &Lum);
extern PACKAGE void __fastcall HSL2RGB(TRGB &px, float iHue, float iSat, float iLum);
extern PACKAGE void __fastcall HSV2RGB(TRGB &px, int H, int S, int V);
extern PACKAGE void __fastcall RGB2HSV(TRGB RGB, int &h, int &s, int &v);
extern PACKAGE TGraphFilter __fastcall LoadFilterFromFile(const System::AnsiString nf);
extern PACKAGE void __fastcall SaveFilterToFile(const System::AnsiString nf, const TGraphFilter &filt
	);
extern PACKAGE void __fastcall _IntensityRGBall(Graphics::TBitmap* bitmap, int r, int g, int b, int 
	fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _Negative(Graphics::TBitmap* bitmap, int fSelx1, int fSely1, int fSelx2
	, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _ContrastRGB(Graphics::TBitmap* bitmap, int vv, int mR, int mG, int mB
	, int fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender
	);
extern PACKAGE void __fastcall _ConvertToGray(Graphics::TBitmap* bitmap, int fSelx1, int fSely1, int 
	fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _Merge(Graphics::TBitmap* bitmap, Graphics::TBitmap* DBitmap, int pcf
	, int fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender
	);
extern PACKAGE void __fastcall _CastColorRange(Graphics::TBitmap* bitmap, TRGB BeginColor, TRGB EndColor
	, TRGB CastColor, int fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* 
	Sender);
extern PACKAGE void __fastcall _Threshold(Graphics::TBitmap* bitmap, TRGB DownLimit, TRGB UpLimit, TRGB 
	DownVal, TRGB UpVal, int fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* 
	Sender);
extern PACKAGE void __fastcall _HistAutoEqualize(Graphics::TBitmap* bitmap, int fSelx1, int fSely1, 
	int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _HistEqualize(Graphics::TBitmap* bitmap, TRGB LoThresh, TRGB HiThresh
	, int fSelx1, int fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender
	);
extern PACKAGE void __fastcall _RotateX(Graphics::TBitmap* bitmap, double angle, TProgressEvent fOnProgress
	, System::TObject* Sender);
extern PACKAGE void __fastcall _Resample(Graphics::TBitmap* Src, Graphics::TBitmap* Dst, TResampleFilter 
	FilterType, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _GetMediaContrastRGB(Graphics::TBitmap* bitmap, int &mR, int &mG, int 
	&mB);
extern PACKAGE void __fastcall _GetHistogram(Graphics::TBitmap* Bitmap, THistogramItem * Hist, int fSelx1
	, int fSely1, int fSelx2, int fSely2);
extern PACKAGE int __fastcall _GetImageNumColors(Graphics::TBitmap* bitmap, int fSelx1, int fSely1, 
	int fSelx2, int fSely2);
extern PACKAGE void __fastcall _Contrast(Graphics::TBitmap* bitmap, int vv, int mm, int fSelx1, int 
	fSely1, int fSelx2, int fSely2, TProgressEvent fOnProgress, System::TObject* Sender);
extern PACKAGE void __fastcall _ConvertTo(Graphics::TBitmap* Bitmap, int NumColors, TProgressEvent fOnProgress
	, System::TObject* Sender);
extern PACKAGE void __fastcall _Negative1Bit(Graphics::TBitmap* Bitmap);
extern PACKAGE Graphics::TBitmap* __fastcall _ConvertTo1bit(Graphics::TBitmap* Bitmap, TRGB &BackCol
	, TRGB &ForeCol);
extern PACKAGE void __fastcall _Conv1to24(Graphics::TBitmap* &SrcBitmap, Graphics::TBitmap* &DstBitmap
	);

}	/* namespace Imageenproc */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Imageenproc;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ImageEnProc
